//
//  QtsHttpComm.h
//  QTSHTTPSDK
//
//  Created by Lawrence on 2013/11/25.
//  Copyright (c) 2013 QNAP Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

/** QtsHttpResult HTTP Header */
#define HTTPHeaderContentLength     @"Content-Length"

/** QtsHttpServer API success or fail error code. */
typedef enum _QTS_HTTP_API_RESULTS_
{
    /** QTS HTTP API unknow */
    QTS_HTTP_APIS_UNKNOW = 0,
    /** QTS HTTP API success */
    QTS_HTTP_APIS_SUCCESS = 0,
    /** QTS HTTP API in progress, return progress rate or total bytes of transferred */
    QTS_HTTP_APIS_SUCCESS_INPROGRESS = 1,
    /** QTS HTTP API abort */
    QTS_HTTP_APIS_SUCCESS_ABORT = 2,
    /** QTS HTTP API need 2 step verification */
    QTS_HTTP_APIS_SUCCESS_NEED_2STEP_VERIFICATION = 4,
    
    /** QTS HTTP API default fail */
    QTS_HTTP_APIS_FAILURE = 50,
    /** Network no connection */
    QTS_HTTP_APIS_FAILURE_NETWORK_NO_CONNECTION = 100,
    /** Network connection failed */
    QTS_HTTP_APIS_FAILURE_NETWORK_CONNECTION_FAILED = 101,
    /** Network timeout */
    QTS_HTTP_APIS_FAILURE_NETWORK_TIMEOUT = 102,
    
    /** Parameter invalid */
    QTS_HTTP_APIS_FAILURE_PARAMETER_INVALID = 200,
    
    /** Server disconnect */
    QTS_HTTP_APIS_FAILURE_SERVER_DISCONNECT = 300,
    /** Server not exist */
    QTS_HTTP_APIS_FAILURE_SERVER_NOT_EXIST = 301,
    /** URL not exist */
    QTS_HTTP_APIS_FAILURE_URL_PATH_NOT_EXIST = 302,
    /** HTTP status code error */
    QTS_HTTP_APIS_FAILURE_HTTP_STATUS_CODE_ERROR = 303,
    /** Not login */
    QTS_HTTP_APIS_FAILURE_NOT_AUTHORIZED = 400,
    /** Login fail */
    QTS_HTTP_APIS_FAILURE_AUTHORIZATION_FAILED = 401,
    /* Proxy authorization required */
    QTS_HTTP_APIS_FAILURE_PROXY_AUTHORIZATION_REQUIRED = 402,
    /* HTTP Found, Focus SSL redirect */
    QTS_HTTP_APIS_FAILURE_HTTP_REDIRECT = 403,
    /** No enough memory */
    QTS_HTTP_APIS_FAILURE_SYSTEM_OUTOFMEMORY = 500,
    /** Parser fail */
    QTS_HTTP_APIS_FAILURE_PARSER_FAILED = 501,
    
    /** Station unsupported */
    QTS_HTTP_APIS_FAILURE_STATION_UNSUPPORTED = 600,
    /** Station not enabled */
    QTS_HTTP_APIS_FAILURE_STATION_NOT_ENABLED = 601,
    /** SID invalid */
    QTS_HTTP_APIS_FAILURE_SID_INVALID = 602,
    /** Station No Privilege */
    QTS_HTTP_APIS_FAILURE_STATION_NO_PRIVILEGE = 603,

    /** File exist */
    QTS_HTTP_APIS_FAILURE_FILE_EXIST = 700,
    /** File not exist */
    QTS_HTTP_APIS_FAILURE_FILE_NOT_EXIST = 701,
    /** File permission denied */
    QTS_HTTP_APIS_FAILURE_FILE_PERMISSION_DENIED = 702,
    
    /** Permission Denied */
    QTS_HTTP_APIS_FAILURE_PERMISSION_DENIED = 800,

}QTS_HTTP_API_RESULTS;

/*!
 * \brief
 * Content of API Response.
 *
 */
@interface QTS_RESPONSE_CTX : NSObject
{
    QTS_HTTP_API_RESULTS result;
    NSArray* response;
}

/** QTS HTTP API result */
@property (assign) QTS_HTTP_API_RESULTS result;
/** QTS HTTP API Response Content */
@property (strong) NSArray* response;

@end




